// IAssembly.h

#pragma once

#ifndef _I_ASSEMBLY_H_
#define _I_ASSEMBLY_H_

struct ClsAssembly;

//------------------------------------------------------------------------------
// IAssembly
//------------------------------------------------------------------------------

class IAssembly
{
public:
	static IAssembly * create();
	static IAssembly * create ( void * buffer, size_t size, bool bAllocated, const char * path );
	virtual ~IAssembly();

// pointer to file in memory (buffer)
	virtual void setBuffer ( void * buffer, size_t size, bool bAllocated ) =0;
	virtual void * getBuffer() const =0;
	virtual void freeBuffer() =0;

// size of file
	//virtual void setBufferSize ( size_t size ) =0;
	virtual size_t getBufferSize() const =0;

// path to file (used in error reporting)
	virtual void setPath ( const char * path ) =0;
	virtual const char * getPath() const =0;

// convert internal class to interface class
	static IAssembly * getIAssembly ( ClsAssembly * assembly );
	static ClsAssembly * getClsAssembly ( IAssembly * assembly );

protected:
	IAssembly();

private:
	IAssembly ( const IAssembly & rhs );
	IAssembly & operator= ( const IAssembly & rhs );
};

//------------------------------------------------------------------------------

#endif // _I_ASSEMBLY_H_
